import java.util.*;
import java.util.stream.*;

public class Sample {
  public static boolean isPrime(int number) {
    // boolean divisible = false;
    // 
    // for(int i = 2; i < number; i++) {
    //   if(number % i == 0) {
    //     divisible = true;
    //     break;
    //   }
    // }
    // return number > 1 && !divisible;
    
    return number > 1 &&
      IntStream.range(2, number)
               .noneMatch(i -> number % i == 0);
  }
	public static void main(String[] args) {
	  //Find the first prime number whose sqrt is greater than 20
	  
    int index = 1;
    while(true) {
      if(isPrime(index) && Math.sqrt(index) > 20) {
        break;
      }
          index++;
    }
    
    System.out.println(index);

	  
	  System.out.println(
	  Stream.iterate(1, e -> e + 1)
	        .filter(Sample::isPrime)
	        .filter(i -> Math.sqrt(i) > 20)
	        .findFirst()
	        .get());
	  
	  //A good code should read like a story, not like a puzzle
	  
	  
	  //lazy evaluation is to FP as polymorphism is to OO
  }
}
